$x_lambert=728500;
$y_lambert=1851000;
$z_lambert=0;
$pi=atan2(1, 1)*4;

$rc = &L_WGS84;

print "Lambert $x_lambert $y_lambert\n";
print "WGS84 $lat_WGS84 $long_WGS84\n";

sub L_WGS84 {
# Paramtres Lambert 2+
$meridien_orig_Paris=0;
$meridien_orig_Greenwich=$meridien_orig_Paris+2.596921296;
$parallele_orig=52;
$X0_lambert=600000;
$Y0_lambert=2200000;
$red_lineaire=0.99987742;

# Paramtres 1880
$a_1880=6378249.200;
$b_1880=6356515.000;
$e_1880=sqrt((($a_1880**2)-($b_1880**2))/($a_1880**2));

# NTF
$parallele_orig_NTF=$parallele_orig/200*$pi;
$latIso_parOrig_NTF=log(sin($pi/4+$parallele_orig_NTF/2)/cos($pi/4+$parallele_orig_NTF/2))-$e_1880/2*log((1+$e_1880*sin($parallele_orig_NTF))/(1-$e_1880*sin($parallele_orig_NTF)));
$R0_NTF=6000431.301;
$x_NTF=$x_lambert-$X0_lambert;
$y_NTF=$Y0_lambert-$y_lambert;
$gamma=atan2($x_NTF,$y_NTF+($red_lineaire*$R0_NTF));
$gamma_rad=$gamma/$pi*200;
$R_NTF=($red_lineaire*$R0_NTF+$y_NTF)/cos($gamma);
$lat_iso=$latIso_parOrig_NTF+log($red_lineaire*$R0_NTF/$R_NTF)/sin($parallele_orig_NTF);
$lat1_NTF=2*atan2(exp($lat_iso),1)-$pi/2;
for ($i=0; $i<=20; $i++)
	{
	$lat2_NTF=2*(atan2(exp($lat_iso+$e_1880/2*log((1+$e_1880*sin($lat1_NTF))/(1-$e_1880*sin($lat1_NTF)))),1))-$pi/2;
	$delta=$lat2_NTF-$lat1_NTF;
#	print "$lat1_NTF $lat2_NTF $delta $lat_NTF \n";
	$lat1_NTF=$lat2_NTF;
}
$lat_NTF=$lat2_NTF/$pi*200;
$long_NTF=$meridien_orig_Paris+$gamma_rad/sin($parallele_orig_NTF);


# Clarke 1880
$lat_1880=($lat_NTF*0.9)/180*$pi;
$v_1880=$a_1880/sqrt(1-(($e_1880**2)*(sin($lat_1880)**2)));
$long_1880=(($long_NTF-$meridien_orig_Paris+$meridien_orig_Greenwich)*0.9)/180*$pi;
$x_1880=($v_1880+$z_lambert)*cos($lat_1880)*cos($long_1880);
$y_1880=($z_lambert+$v_1880)*cos($lat_1880)*sin($long_1880);
$z_1880=($v_1880*(1-($e_1880**2))+$z_lambert)*sin($lat_1880);

# GRS80
$tx_GRS80=168;
$ty_GRS80=60;
$tz_GRS80=-320;
$a_GRS80=6378137;
$b_GRS80=6356752.314;
$e2_GRS80=abs($b_GRS80*$b_GRS80-$a_GRS80*$a_GRS80)/$a_GRS80/$a_GRS80;
$x_GRS80=$x_1880-$tx_GRS80;
$y_GRS80=$y_1880-$ty_GRS80;
$z_GRS80=$z_1880-$tz_GRS80;
$re_GRS80=sqrt($x_GRS80**2+$y_GRS80**2);
$lat1_GRS80=$lat_1880;
for ($i=0; $i<=20; $i++)
	{
	$lat2_GRS80=atan2(($z_GRS80+$e2_GRS80*sin($lat1_GRS80)*$a_GRS80/sqrt(1-$e2_GRS80*sin($lat1_GRS80)**2)),$re_GRS80);
	$delta=$lat2_GRS80-$lat1_GRS80;
#	print "$lat1_GRS80 $lat2_GRS80 $delta $lat_GRS80\n";
	$lat1_GRS80=$lat2_GRS80;
}
$lat_GRS80=$lat2_GRS80;
$long_GRS80=atan2($y_GRS80,$x_GRS80); 

# WGS84
$lat_WGS84=$lat_GRS80/$pi*180;
$long_WGS84=$long_GRS80/$pi*180;
return 0;
}